/*
 * 2004-11-11 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.data;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.jdom.Attribute;
import org.jdom.Element;

/**
 *  NodeDataÿڵҪЯ
 */
public class NodeData {
	private String name = "";

	private String elementName = "";

	private String path = "";

	private HashMap properties = new HashMap();

	public NodeData() {

	}

	public NodeData(Element element) {
		List list = element.getAttributes();
		Iterator it = list.iterator();
		Attribute attribute;
		String property;
		String value;
		while (it.hasNext()) {
			attribute = (Attribute) it.next();
			property = attribute.getName();
			value = element.getAttributeValue(property);
			this.setProperty(property, value);
		}
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getElementName() {
		return elementName;
	}

	public void setElementName(String elementName) {
		this.elementName = elementName;
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}

	/**
	 * setPropertyԵֵ
	 * 
	 * @param key --
	 *            
	 * @param value --
	 *            Եֵ
	 */
	public void setProperty(String key, String value) {
		String property = "";
		properties.remove(key);
		properties.put(key, value);
	}

	/**
	 * getPropertyȡָԶӦֵ
	 * 
	 * @param key --
	 *            
	 * @return ֵ
	 */
	public String getProperty(String key) {
		String property = "";
		property = (String) this.properties.get(key);
		if (property == null)
			property = "";
		return property;
	}

	/**
	 * @return ؿڵҪʾ
	 */
	public String toString() {
		String result = "";
		result = (String) this.getName();
		if (result == null)
			result = " ";
		return result;
	}

	/**
	 * @return ضӦxmlԪصıǩ
	 */
	public String getOpenElement() {
		String result = "<" + this.getElementName();
		String content = "";
		Set set = this.properties.keySet();
		Iterator it = set.iterator();
		while (it.hasNext()) {
			String property = (String) it.next();
			String value = this.getProperty(property);

			if (value == null || value.equals(""))
				;
			else
				content = " " + property + "=\"" + value + "\"" + content;
		}
		result = result + content + " >";
		return result;
	}

	/**
	 * @return TaskӦxmlԪصĹرձǩ
	 */
	public String getCloseElement() {
		String result = "</" + this.getElementName() + ">";
		return result;
	}
}