/*
 * 2004-11-11 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.util;

import java.io.InputStream;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

/**
 * BuildFileTemplateȡļ,ûpath,ûϣelement
 */
public class BuildFileTemplate {

	public InputStream in = getClass().getResourceAsStream("/ant.xml");

	Document document = null;

	public BuildFileTemplate() {
		try {
			SAXBuilder builder = new SAXBuilder();
			document = builder.build(in);
		} catch (Exception e) {
		}
	}

	public Element getElementByPath(String name) {
		Element element = null;
		if (name.trim().toLowerCase().equals("project"))
			element = this.document.getRootElement();
		else
			element = this.getElementByPath(this.document.getRootElement(),
					name.substring(name.indexOf(",") + 1));

		return element;
	}

	public Element getElementByPath(Element father, String name) {

		Element element = null;
		List list = father.getChildren(name);
		if (list.size() == 0) {
			int commaLocation = name.indexOf(",");
			if (commaLocation > -1) {
				String fatherElementName = name.substring(0, commaLocation);
				String childElementName = name.substring(commaLocation + 1);
				list = father.getChildren(fatherElementName);
				if (list.size() > 0) {
					Element child = (Element) list.get(0);
					element = getElementByPath(child, childElementName);
				}
			}
		} else {
			element = (Element) list.get(0);
		}
		return element;
	}

}